clc;
clear;
close all;
filename = 'combined_data14.xlsx';

% ȡExcelļ
data = readtable(filename);

VR_X = str2double(data.VR_X);
VR_Y = str2double(data.VR_Y);
VR_Z = str2double(data.VR_Z);

Dist = data.D;
raw_pdoa = data.P;
UWB_X = data.Xcm;
UWB_Y = data.Ycm;

pdoa_offset = 0.0;
Lambda = 3e8/6.5e9;    % UWB
D_M = 0.0208;          % ߼

raw_pdoa = raw_pdoa - pdoa_offset;
% PDOA쳣ֵ
pdoa = OutlierFilter(raw_pdoa);

% PDOA˲ǰԱͼ
figure
plot(raw_pdoa);hold on
plot(pdoa);
legend('ԭʼPDOA','쳣PDOA');
title('PDOA쳣ǰԱ');
xlabel('Time');  % Xǩ
ylabel('λ ');  % Yǩ

pdoa_filtered = firstOrderFilter(pdoa, 0.9);

% PDOA˲ǰԱͼ
figure
plot(pdoa);hold on
plot(pdoa_filtered);
legend('δ˲PDOA','˲PDOA');
title('PDOA˲ǰԱ');
xlabel('Time');  % Xǩ
ylabel('λ ');  % Yǩ

dist_filtered = firstOrderFilter(Dist, 0.9);

figure
plot(Dist);hold on
plot(dist_filtered);
legend('ԭʼ','˲');
title('˲ǰԱ');
xlabel('Time');  % Xǩ
ylabel('λ ');  % Yǩ


% ԭʼpdoaźżAOA
aoa = CalUWBAOA(pdoa);
% ˲źżAOA
aoa_filtered = CalUWBAOA(pdoa_filtered);

% AOA˲ǰԱͼ
figure
plot(aoa);hold on
plot(aoa_filtered);
legend('δ˲AOA ','˲AOA');
title('AOAδ˲˲PODAԱ');
xlabel('Time');  % Xǩ
ylabel('Angle (Ƕȡ)');  % Yǩ

filter_x = dist_filtered .* sin(aoa_filtered / 180 * pi) / 100;
filter_y = dist_filtered .* cos(aoa_filtered / 180 * pi) / 100;

% % AOA˲ǰԱͼ
% figure
% plot(UWB_X/100,UWB_Y/100);hold on
% plot(filter_x,filter_y);
% plot(-VR_X,-VR_Z);
% legend('ԭʼλ ','˲㶨λ','lighthouseֵ');
% title('λ˲ǰԱ');
% xlabel('X(m)');  % Xǩ
% ylabel('Y(m)');  % Yǩ


% lighthouseת
angle_degrees = 90;  % 磬90
angle_radians = deg2rad(angle_degrees);  % תΪ
% ת
R = [cos(angle_radians) -sin(angle_radians); sin(angle_radians) cos(angle_radians)];
x_l = -VR_X;
y_l = -VR_Z;
points = [x_l'; y_l'];
rotated_points = R * points;

% ȡת x  y 
x_lr = rotated_points(1, :)' + 1.0;
y_lr = rotated_points(2, :)' + 0.8;

n = 500;
% AOA˲ǰԱͼ
figure
plot(filter_x(1:n),filter_y(1:n),'b.');hold on
plot(x_lr(1:n),y_lr(1:n));
legend('˲㶨λ','lighthouseֵ');
title('λ˲ǰԱ');
xlabel('X(m)');  % Xǩ
ylabel('Y(m)');  % Yǩ

err_x = mean(abs(filter_x -x_lr));
err_y = mean(abs(filter_y -y_lr));

fprintf('UWBLighthouseֵ Error X: %.2f m,Y: %.2f m\n',err_x,err_y);


